<?php
/**
 * @version 1.0 $Id: select.php 175 2009-11-07 10:24:30Z vistamedia $
 * @package Joomla
 * @subpackage FLEXIcontent
 * @subpackage plugin.select
 * @copyright (C) 2009 Emmanuel Danan - www.vistamedia.fr
 * @license GNU/GPL v2
 *
 * FLEXIcontent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.event.plugin');

class plgFlexicontent_fieldsKcomment extends JPlugin {

	function plgFlexicontent_fieldsKcomment( &$subject, $params ) {
		parent::__construct( $subject, $params );
    JPlugin::loadLanguage('plg_flexicontent_fields_kcomment', JPATH_ADMINISTRATOR);
    $this->_debug = true;
    $this->_includedCss	= false;
    $this->_botFallbackToSubject = false;	
	}

  // ---------------------------------------------------
  // Begin of standard plugin callback function
  // ---------------------------------------------------
	function onDisplayField(&$field, &$item) {
		// execute the code only if the field type match the plugin type
    $this->debug("Call of onDisplayField");
		if($field->field_type != 'kcomment') return;

		// some parameter shortcuts
		$required = $field->parameters->get( 'required', 0 ) ;
		$field_kforumcatid = $field->parameters->get( 'field_kforumcatid' ) ;
		$default_kforumid	= $field->parameters->get( 'default_kforumid' ) ;
						
		$required = $required ? 'class="required"' : null;

		// initialise property
		if(!$field->value || $field->value[0] == '') {
			$field->value[0] = $default_kforumid;
			}

		$db =& JFactory::getDBO();
	
		$query = "select id, name from #__fb_categories where parent={$field_kforumcatid}";
		$db->setQuery($query);
		$results = $db->loadObjectList();
		
		if (!$results) {
			$field->html = JText::_('FLEXI_FIELD_INVALID_QUERY');		
		} else {		
			$options = array();
			foreach($results as $result) {
				$options[] = JHTML::_('select.option', $result->id, $result->name);
			}
			$field->html	= JHTML::_('select.genericlist', $options, $field->name, $required, 'value', 'text', $field->value);
		}
		
	}

	function onBeforeSaveField( &$field, &$post, &$file ) {
		// execute the code only if the field type match the plugin type
    $this->debug("Call of onBeforeSaveField");
		if($field->field_type != 'kcomment') return;
		if(!$post) return;		
			
		$searchindex .= '';

		$field->search = $field->issearch ? $searchindex : '';
		
	}

	function onDisplayFieldValue(&$field, &$item, $values=null, $prop='display') {
		// execute the code only if the field type match the plugin type
    $this->debug("Call of onDisplayFieldValue");
		if($field->field_type != 'kcomment') return;
		
		$botShowOnFrontPage = $field->parameters->get('show_front_page');
		$botShowOnBlogPages = $field->parameters->get('show_blog_pages');
		$botShowOnOtherPages = $field->parameters->get('show_other_pages');
		$botCopyContent = $field->parameters->get('copy_content', 2);
		// Override config setting when using FB to add the link back to the article in first posts
		if ($botCopyContent == 0) {
			$this->_botFallbackToSubject = true;
		}

    $menu = & JSite::getMenu();
		$isFrontPage = ($menu->getActive() == $menu->getDefault());
		$isBlogPage = false; //JRequest::getVar('layout') == 'blog'; // before && (JRequest::getVar('view') == 'category') || JRequest::getVar('view') == 'section');
		if ($isBlogPage) {
			$show = $botShowOnBlogPages;
		} else if ($isFrontPage) {
			$show = $botShowOnFrontPage;
		} else {
			$show = $botShowOnOtherPages;
		}
		
		$values = $values ? $values : $field->value ;
		$db = &JFactory::getDbo();	

		// create discussbot table if doesn't exist
		$query = "SHOW TABLES LIKE '{$db->_table_prefix}fb_kcomment'";
		$db->setQuery($query);
		if ($db->loadResult()===null) {
		  $this->debug("Cration de la table fb_kcomment.");
			$query = "CREATE TABLE IF NOT EXISTS `#__fb_kcomment` 
					(`item_id` int(11) NOT NULL default '0', 
					 `thread_id` int(11) NOT NULL default '0',  
					 PRIMARY KEY  (`item_id`) 
					 )";  
			$db->setQuery($query);
			if (!$db->query()) {
  		  $this->debug("Echec de la ration de la table fb_kcomment.");
				$db->stderr();
				return false;
      } else{
  		  $this->debug("Russite de la ration de la table fb_kcomment.");
			}
    } else {
    	$this->debug("La table fb_kcomment existe dj.");		
		}			
		if (intval($values[0])&&$show) {
			$display = $this->make_kforumlink($item, $field, $values[0], $show == 1);
		} else {
			$display = '';
		}
    //$this->debug("Display is [".$display."]");

		$field->{$prop}	= $display;
	}

	function onDisplayFilter(&$filter, $value='') {
		// execute the code only if the field type match the plugin type
    $this->debug("Call of onDisplayFilter");
		if($filter->field_type != 'kcomment') return;
		
		$filter->html	= '';
	}
  // ---------------------------------------------------
  // End of standard plugin callback function
  // ---------------------------------------------------

	//******************************************************************************
  // Internal functions follows ***
	//******************************************************************************
	function InsertContentAsFirstPost( &$item, &$field, $catid, $subject, $prefix, &$insertTime, $ipAddy) {
    $this->debug("Call of InsertContentAsFirstPost");
		$botFirstPostOwnerId = $field->parameters->get('first_post_owner', 0);
		$botCopyContent = $field->parameters->get('copy_content', 2);
		
		$db = &JFactory::getDbo();
	
		$fbConfig =& CKunenaConfig::getInstance(); 
	
		// Lookup name and email address for the content author 
		$author = (int)$botFirstPostOwnerId;
		if (!$author) {
			$author = $item->created_by;
		}
		
		$nameCol = $fbConfig->username ? "username" : "name";
		$query = "SELECT {$nameCol} AS name, email FROM #__users WHERE id = '$author'";
		$db->setQuery($query);
		if (!$rows = $db->loadObjectlist()) {
			$this->debug("Failed to load author info:" . $db->stderr(), 1);
			return $db->stderr();
		}
			
		$email = $rows[0]->email; 
		$name = $rows[0]->name;
		$thread = ''; // Leave blank 'cause they're ALL new!
		
		// Update the author post count because that's very important to people!!!  ;)
		$db->setQuery("UPDATE #__fb_users SET posts=posts+1 WHERE userid='$author'");
		if (!$db->query()) {
			$this->debug("Failed to update article author's post count:" . $db->stderr(), 1);
			return $db->stderr();
		}
		
		$query = "INSERT INTO #__fb_messages (id, parent, thread, catid, name, userid, email, subject, time, ip) VALUES ('', '', '$thread', '$catid', '$name', '$author', '$email', '$subject', '$insertTime', '$ipAddy')";
		$db->setQuery($query);
		if (!$db->query()) {
			$this->debug("Failed to insert new post:" . $db->stderr(), 1);
			echo $db->stderr();
			return 0;
		}		
	
		// Reselect the new ID using the value for timestamp
		$query = "SELECT min(id) FROM #__fb_messages WHERE time='$insertTime'";
		$db->setQuery($query);
		if (!$newMessageId = $db->loadResult()) {
			$this->debug("Failed to load id for new post:" . $db->stderr(), 1);
			echo $db->stderr();
			return 0;
		}		
		// We need to Update new Threads with the thread ID
		if ($thread == '' || $thread == 0) {
			$db->setQuery("UPDATE #__fb_messages set thread = id WHERE id = '$newMessageId'");
			if (!$db->query()) {
				$this->debug("Failed to set threadId on new post:" . $db->stderr(), 1);
				echo $db->stderr();
				return 0;
			}
			
			// Keep a cross reference of Threads we create through this bot!
			$query = "INSERT INTO #__fb_kcomment (item_id, thread_id) VALUES ('{$item->id}', '$newMessageId')";
			$db->setQuery($query);
			if (!$db->query()) {
				$this->debug("Failed to insert cross reference record:" . $db->stderr(), 1);
				echo $db->stderr();
				return 0;
			}
		}
		
		// Copy content item to the first post.   $botCopyContent:  0 = Nothing, 1 = Link & Full Text, 2 = Link Only
		$posttext = '';
		if ($botCopyContent == 1) {
			// Append the "This thread discusses..." link to the front of the article text
			if ($item->fulltext) {
				$fulltext = $item->fulltext;
			} else {
				$query = "SELECT a.fulltext FROM #__content AS a WHERE a.id = " . (int)$item->id;
				$db->setQuery($query);
				if (false === $fulltext = $db->loadResult()) {
					$this->debug("Failed to select article full text:" . $db->stderr(), 1);
					echo $db->stderr();
					return 0;
				}
			}
			$posttext = $item->introtext . "\n\n" . $fulltext;
			$posttext = preg_replace("/{mos_fb_discuss:$catid}/", '', $posttext, 1);
			$posttext = preg_replace("/{mosimage}/", '', $posttext);
		}
		
		// Assemble and cleanup the thread message text
		$posttext = htmlspecialchars_decode($posttext, ENT_QUOTES);
		$posttext = addslashes($posttext);

		// Convert headings to bold or italic text and a line break
		$posttext = preg_replace("%<h1>%si", "<b>", $posttext);
		$posttext = preg_replace("%</h1>%si", "</b>\n", $posttext);
		$posttext = preg_replace("%<h2>%si", "<i>", $posttext);
		$posttext = preg_replace("%</h2>%si", "</i>\n", $posttext);
		$posttext = preg_replace("%<h3>%si", "<i>", $posttext);
		$posttext = preg_replace("%</h3>%si", "</i>\n", $posttext);
		// Any others?
		
		// Add an extra linebreak after the end of a paragraph.
		$posttext = preg_replace("%</p>%si", "</p>\n", $posttext);
		$posttext = smile::fbStripHtmlTags($posttext);
	
		// mosMakeHtmlSafe($posttext);	
		$message = $prefix . "\n\n" . $posttext;
			
		$query = "INSERT INTO #__fb_messages_text(mesid, message) VALUES ('$newMessageId', '$message')";
		$db->setQuery($query);
		if (!$db->query()) {
			$this->debug("Failed to insert message text on new post:" . $db->stderr(), 1);
			echo $db->stderr();
			return 0;
		}
		
		// Update the category with the new topic / last post info
		$query = "UPDATE #__fb_categories SET time_last_msg='$insertTime', id_last_msg='$newMessageId', numTopics = numTopics+1, numPosts = numPosts+1 WHERE id='$catid'";
		$db->setQuery($query);
		if (!$db->query()) {
			$this->debug("Failed to update category info on new post:" . $db->stderr(), 1);
			echo $db->stderr();
			return 0;
		}
		
		$insertTime++;
		// We'll need to know about the new Thread id later...
		return $newMessageId;
	}

	/******************************************************************************
	 *
	 *****************************************************************************/
	function make_kforumlink(&$item, &$field, $catid, $linkOnly) {
    $this->debug("Call of make_kforumlink");
		$botShowForm = $field->parameters->get('form', true);
		$botUseButton = $field->parameters->get('use_button', false);
		$botQuickPostOnTop = $field->parameters->get('quickpost_on_top', false);
		$botAllowPublicPost = $field->parameters->get('allow_public', false);
    $botCopyContent = $field->parameters->get('copy_content', 2);
	
		$db = &JFactory::getDbo();
		$my = &JFactory::getUser();
	  	
		require_once(JPATH_SITE.DS.'components'.DS.'com_kunena'.DS.'lib'.DS.'kunena.defines.php');
		require_once(KUNENA_PATH_LIB.DS.'kunena.debug.php');
		require_once(KUNENA_PATH_LIB.DS.'kunena.config.class.php');
		require_once(KUNENA_COMPONENT_RELPATH.DS.'class.kunena.php');
		if (file_exists(KUNENA_ABSTMPLTPATH .DS. 'smile.class.php')) {
			require_once(KUNENA_ABSTMPLTPATH.DS.'smile.class.php');
		} else {
			require_once(KUNENA_PATH_TEMPLATE_DEFAULT.DS.'smile.class.php');
		}

		$fbConfig =& CKunenaConfig::getInstance(); 
	
		if (!$fbConfig->discussbot) {
			$this->debug("Kunena Config has the bot disabled!");
			return '';
		}
		
		if (!defined('_KUNENA_EMOTICONS_MORE_SMILIES'))
			DEFINE('_KUNENA_EMOTICONS_MORE_SMILIES', JText::_('FCKC_KUNENA_EMOTICONS_MORE_SMILIES'));
		
			
		// Don't repeat the CSS for each instance of this bot in a page!
		if (!$this->_includedCss) {
			$doc =& JFactory::getDocument();
	
			// Add CSS for the bot
			$doc->addStyleSheet(KUNENA_JLIVEURL.'plugins/flexicontent_fields/kcomment/discuss.css');
			$mainframe =& JFactory::getApplication('site');
			$mainframe->addCustomHeadTag('<!--[if IE 7]>');
			$mainframe->addCustomHeadTag('<link type="text/css" rel="stylesheet" href='.KUNENA_JLIVEURL.'plugins/flexicontent_fields/kcomment/discuss_ie7.css" />');
			$mainframe->addCustomHeadTag('<![endif]-->');
			$mainframe->addCustomHeadTag('<script language="javascript" type="text/javascript">');
			$mainframe->addCustomHeadTag('var langkd=new Array("'.JText::_('FCKC_PLEASE_ENTER_YOUR_NAME').'","'.JText::_('FCKC_PLEASE_ENTER_A_VALID_EMAIL_ADDRESS').'","'.JText::_('FCKC_CAPTCHA_MISSING').'","'.JText::_('FCKC_PLESE_ENTER_SOME_TEXT').'","'.JText::_('FCKC_UNABLE_TO_VALIDATE_FORM').'");');
			$mainframe->addCustomHeadTag('</script>');
	
			// Include JQuery
			if (!defined('C_ASSET_JQUERY')) {
				define( 'C_ASSET_JQUERY', 1 );
				$doc->addScript(KUNENA_JQURL);
			}
			$doc->addScript(KUNENA_JLIVEURL.'plugins/flexicontent_fields/kcomment/discuss.js');
			
			$this->_includedCss = true;
		}
		
		$subject = trim(htmlspecialchars(addslashes(addslashes($item->title)))); 
		
		$ipAddy = $_SERVER['REMOTE_ADDR'];
		$insertTime = time() + ($fbConfig->board_ofset * 3600);	// Use the same offset as the forum
		
	
		$query = "SELECT min(thread_id) FROM #__fb_kcomment WHERE item_id = '{$item->id}' ";
		$db->setQuery($query);
		// This is also the thread id!
		if (false === $resultid = $db->loadResult()) {
			$this->debug("Failed to select threadid from cross reference:" . $db->stderr(), 1);
			return $db->stderr();
		}
		if ($resultid) {
			// Does this thread still exist in the forum or has it been deleted?
			$this->debug("Found the FB threadId in the cross reference table(#__fb_kcomment).");	
			$query = "SELECT count(*) FROM #__fb_messages WHERE id='$resultid'";
			$db->setQuery($query);
			$foundId = $db->loadResult();
			if (!$foundId) {
				// It's been deleted from the forum.  Delete the bad x-reference record!!
				$query = "DELETE FROM #__fb_kcomment WHERE thread_id = '$resultid'";
				$db->setQuery($query);
				if (!$db->query()) {
					$this->debug("Failed to delete stale cross reference record:" . $db->stderr(), 1);
					return $db->stderr();
				}
				$this->debug("Removed cross reference record pointing to a non-existent FB threadId.");
				$resultid = '';
			}
		} else {
			// Fallback to the old method for existing threads!
			if ($this->_botFallbackToSubject) {
				$query = "SELECT min(id) FROM #__fb_messages WHERE catid='$catid' AND subject='$subject'";
				$db->setQuery($query);
				if (false === $resultid = $db->loadResult()) {
					$this->debug("Failed to select thread by subject match:" . $db->stderr(), 1);
					return $db->stderr();
				}			
				if ($resultid) {
					// Keep a cross reference of Threads we find through this bot!
					$query = "INSERT INTO #__fb_kcomment (item_id, thread_id) VALUES ('{$item->id}', '$resultid')";
					$db->setQuery($query);
					if (!$db->query()) {
						$this->debug("Failed to insert cross reference record for subject match:" . $db->stderr(), 1);
						echo $db->stderr();
						return 0;
					}
					$this->debug("Updated cross reference table with the FB threadId found by subject matching.");
				} else {
					$this->debug("Did not locate an existing thread by Subject match.");
				}
			}
		}
	
		require_once(JPATH_SITE.DS.'components'.DS.'com_flexicontent'.DS.'helpers'.DS.'route.php');  
    $prefix = JRoute::_(FlexicontentHelperRoute::getItemRoute($item->id));
    
			// Only slightly different from the tag that's inserted by the default forum bot link so I can tell them apart!  ( Included **'s )
		$prefix = sprintf(JText::_('FCKC_THIS_THREAD_DISCUSSES'), JText::_('FCKC_POST_DISCUSS'), $prefix, $item->title);
		$prefix = trim(addslashes($prefix));
		 
		// ************************************************************************	
		// Process New posts where we're putting the content into the first forum post
		// ************************************************************************
		if (JRequest::getInt('fb_firstpost', 0, 'POST') == $item->id) {
			if ($resultid = '' || $resultid == 0) {
				$resultid = $this->InsertContentAsFirstPost($item, $field, $catid, $subject, $prefix, $insertTime, $ipAddy);
				if ($resultid) {
					// $url = "index.php?option=com_kunena&Itemid=$Itemid&func=post&do=reply&replyto=$resultid&catid=$catid";
					$app = &JFactory::getApplication();
					$app->redirect(JRoute::_("index.php?option=com_kunena&Itemid=".KUNENA_COMPONENT_ITEMID."&func=view&id=$resultid&catid=$catid"));
					return;
				}
				return "Error:  Failed to insert first post!";
			} else {
				$this->debug("It appears there's already a first-post for this content item.");
			}
		}
		
		// ************************************************************************	
		// Process the QuickPost form 
	
		// $this->debug("Public " . ($botAllowPublicPost ? "has" : "does NOT have") . " permissions to post in FB category " . $catid . ".");
		
		if ($my->id) {
			// If user is logged in - do they have permission to post to this FB category?
			$isMod = $this->IsModerator($catid);
			$postPerms = $this->HasPostPerms($catid, $resultid, $isMod);
			// $this->debug("User " . ($postPerms ? "has" : "does NOT have") . " permissions to post in FB category " . $catid . ".");
		} else {
			$isMod = false;
			$postPerms = false;
		}
	
		$quickPost = '';
		if(!$botAllowPublicPost && !$my->id) {
				if ($fbConfig->fb_profile == 'cb') {
					$loginlink = CKunenaCBProfile::getLoginURL();
					$registerlink = CKunenaCBProfile::getRegisterURL();
				} else {
					$loginlink = JRoute::_('index.php?option=com_user&amp;view=login');
					$registerlink = JRoute::_('index.php?option=com_user&amp;view=register&amp;Itemid='.KUNENA_COMPONENT_ITEMID);
				}
				$quickPost = sprintf(JText::_('FCKC_LOGIN_OR_REGISTER_TO_COMMENT'), $loginlink, $registerlink);
				$quickPost .= "<br />";
				$this->debug("User is not logged in and public posting is not permitted.");
		} else {
			$this->debug("User is". ($my->id ? " " : " not ") ."logged in.");
			$this->debug("Article Id is ".$item->id);
	
			// User *is* logged in or Public Posting is allowed!
			if($botShowForm && ($botAllowPublicPost || $postPerms)) {
				
				if((JRequest::getInt('kdbContentId',0,'POST') == $item->id) && (JRequest::getString('message','','POST') || JRequest::getString('name','','POST'))) {
				
					$this->debug("Handling Form Post from QuickPost.  resultid=" . $resultid . ", Id=" . $item->id);
					$quickPost .= $this->HandlePostFromQuickPost($item, $field, $postPerms, $resultid, $prefix, $isMod, $catid, $subject, $insertTime, $ipAddy);
					
				} else {
					$this->debug("Building QuickPost form for Id " . $item->id);
					$quickPost .= $this->BuildQuickPostForm($item, $field);
				}
				$quickPost .= '<br />';
			}
		}
			
		$actualPostCount = 0;
	
		// If there is no result from the first query let the link open a new reply possibility
		$showlink = '';
		if ($resultid == '') {
			$showlink = JRoute::_("index.php?option=com_kunena&Itemid=".KUNENA_COMPONENT_ITEMID."&func=post&do=newFromBot&resubject=".strtr(base64_encode($item->title), "+/", "()")."&catid=$catid&rowid={$item->id}&rowItemid=".KUNENA_COMPONENT_ITEMID);
		} else {
			// Find out how many posts are actually in the thread 
			$sql = "SELECT count(id) from #__fb_messages where thread=$resultid";
			$db->setQuery($sql);
			if (!$actualPostCount = $db->loadResult()) {
				$this->debug("Failed to count posts in thread:" . $db->stderr(), 1);
				return $db->stderr();
			}			
			$this->debug("Counted {$actualPostCount} actual post(s) in this thread #{$resultid}.");
			// Create a link to the FB thread and hang on to it until we need it
			$showlink = JRoute::_("index.php?option=com_kunena&Itemid=".KUNENA_COMPONENT_ITEMID."&func=view&id=$resultid&catid=$catid");
		}
		
		// This will be used all the way through to tell users how many posts are in the forum.
		$displayedPostCount = 0;
		$content = '';
		if ($linkOnly) {
			$this->debug("Displaying Intro, link to the forum only.");
			
			$quickPost = '';  // Dump it.
			
			// Updated to match the same number that would be seen when displaying all the posts.
			// E.g. Remove the holds and remove the first thread where creating a separate post with the bot.
			if ($actualPostCount > 0) {
				// Remove the holds and remove the first thread where creating a separate post with the bot.
				if ($botCopyContent > 0) {
					$sql = "SELECT count(id) from #__fb_messages where hold=0 AND thread!=id AND thread=$resultid";
				} else {
					$sql = "SELECT count(id) from #__fb_messages where hold=0 AND thread=$resultid";
				}
				$this->debug("Counting posts with:" . $sql);
				$this->debug("botCopyContent:" . $botCopyContent);
				$db->setQuery($sql);
				if (false === $displayedPostCount = $db->loadResult()) {
					$this->debug("Failed to count displayed posts in thread for front page:" . $db->stderr(), 1);
					return $db->stderr();
				}			
				$this->debug("Counted {$displayedPostCount} displayed posts in this thread with holds and the copied content removed.");
			} else {
				$this->debug("There are zero actual posts in this thread, there are by default zero displayed posts.");
			}
		} else {
			if ($botCopyContent == 0 && $actualPostCount > 0 || $botCopyContent > 0 && $actualPostCount > 1) {
				$this->debug("Rendering Comments with $actualPostCount actual posts.");
				$content = $this->RenderComments($item, $field, $actualPostCount, $resultid);
				// Update the $displayedPostCount as it's used to print a link indicating the number of posts eligible for display.
				$displayedPostCount = $actualPostCount;
			} else {
				$this->debug("There are zero actual posts in this thread, there are by default zero displayed posts.");
			}
		}
	 
		$link = '';
		// TODO $botCopyContent 0..2 
		if ($botCopyContent && $resultid == '') {
			$this->debug("Building a link to create first post when not delegating it to Kunena.");
			// Build the form used to create the first post when we're not delegating it to FB
			$link .= '<span class="kdb-full-page">';
			if ($botUseButton) {
				$link .= '<a href="javascript:document.getElementById(\'first'.$item->id.'\').submit();"><img src="'.KUNENA_JLIVEURL.'plugins/flexicontent_fields/kcomment/discuss.png" border="0" alt="'. JText::_('FCKC_DISCUSS_DOTDOTDOT') .'" title="'.sprintf(JText::_('FCKC_DISCUSS_ON_FORUMS_X_POSTS'), $displayedPostCount).'" /></a>';
			} else {
				$link .= '<a href="javascript:document.getElementById(\'first'.$item->id.'\').submit();">'.sprintf(JText::_('FCKC_DISCUSS_ON_FORUMS_X_POSTS'), $displayedPostCount).'</a>';
			}
			$link .= '</span>';
			$link .= '<form method="post" id="first'.$item->id.'" name="first'.$item->id.'">
							<input type="hidden" name="fb_firstpost" value="'.$item->id.'" /></form>';
		} else {
			// Build a simple link to create the new posts
			$this->debug("Building a simple link to create new posts.");
			$link .= '<span class="kdb-full-page">';
			if ($botUseButton) {
				$link .= '<a href="'.$showlink.'"><img src="'.KUNENA_JLIVEURL.'plugins/flexicontent_fields/kcomment/discuss.png" border="0" alt="'. JText::_('FCKC_DISCUSS_DOTDOTDOT') .'" title="'.sprintf(JText::_('FCKC_DISCUSS_ON_FORUMS_X_POSTS'), $displayedPostCount).'" /></a>';
			} else {
				$link .= '<a href="'.$showlink.'">'.sprintf(JText::_('FCKC_DISCUSS_ON_FORUMS_X_POSTS'), $displayedPostCount).'</a>';
			}	
			$link .= '</span>';
		}
	
	 	// Apend the results of QuickPost
		$this->debug("Showing QuickPost " . ($botQuickPostOnTop?"above":"below") . " the article comments.");
		if ($botQuickPostOnTop) {
			$content = "<br />" . $quickPost . $link . "<br />" . $content;
		} else {
			$content = $content . "<br />" . $quickPost . $link;
		}
		
		return $content;
	}


	/******************************************************************************
	 *  
	 *****************************************************************************/
	function getAvatar($userid) {
    $this->debug("Call of getAvatar");
		$fbConfig =& CKunenaConfig::getInstance(); 
		$db = &JFactory::getDBO();

		switch ($fbConfig->avatar_src) {
			case 'jomsocial':
				$user = &CFactory::getUser($userid);
				$msg_avatar = $user->getThumbAvatar();
				break;
			case 'clexuspm': 
				$msg_avatar = MyPMSTools::getAvatarLinkWithID($userid);
				break;
			case 'cb':
				$db->setQuery("SELECT avatar FROM #__comprofiler WHERE user_id=$userid AND avatarapproved=1");
				$avatar = $db->loadResult();
				if ($avatar) {
					$avatar = (strpos($avatar, 'gallery/') === false) ? 'tn' . $avatar : $avatar;
					$msg_avatar = KUNENA_JLIVEURL . "images/comprofiler/$avatar";
				} else {
					$msg_avatar = KUNENA_JLIVEURL . 'components/com_comprofiler/plugin/language/default_language/images/tnnophoto.jpg';
				}
				break;
			default:
				$db->setQuery("SELECT avatar FROM #__fb_users WHERE userid = $userid");
				$avatar = $db->loadResult();
				$avatar = ($avatar) ? $avatar : 's_nophoto.jpg';
				$msg_avatar = KUNENA_LIVEUPLOADEDPATH . "/avatars/$avatar";
		}
		return "<span><img src=\"$msg_avatar\" alt=\"\" /></span>";
	}

	/******************************************************************************
	 *  
	 *****************************************************************************/
	function RenderComments(&$item, &$field, &$countPosts, $resultid) {
    $this->debug("Call of RenderComments");

		require_once(JPATH_SITE.DS.'components'.DS.'com_kunena'.DS.'lib'.DS.'kunena.link.class.php');

		$botPostLimit = $field->parameters->get('kunena_post_limit', 25);  // Limits the number of posts
		$botFirstPosts = $field->parameters->get('first_posts', true);  // Show the first X posts, versus the last X posts
		$botLastPostTop = $field->parameters->get('last_post_top', false); // Show the last post at the top
		$botCopyContent = $field->parameters->get('copy_content', 2);  // Copy content item to the first post.  0 = Nothing, 1 = Link & Full Text, 2 = Link Only
		$botPageBreakComment = $field->parameters->get('pagebreak_comment', false);

		$db = &JFactory::getDbo();
		$fbConfig =& CKunenaConfig::getInstance(); 
		$s = '';
	
		if ((int)$botPostLimit <= 0) return '<span class="kdb-dsc-no-comments-b"></span>';
		
		$skipCounter = 0;
		$displayNum = 0;
		
		$this->debug("Limiting rendered comments to ".(int)$botPostLimit." posts.");
		
		// Updated to include message text and User info in one query!!
		$query = "  SELECT m.id, m.thread, m.hold, m.userid, m.name, m.time, m.catid, m.subject, u.avatar, mt.message";
		$query .=  "    FROM `#__fb_messages` AS m";
		if ($fbConfig->avatar_src == "cb") {
			// Option to use the CB avatar!
			$query .= "    LEFT JOIN `#__comprofiler` AS u ON (m.userid = u.user_id)";
		} else {
			$query .= "    LEFT JOIN `#__fb_users` AS u ON (m.userid = u.userid)";
		}
		$query .= "    LEFT JOIN `#__fb_messages_text` AS mt ON (mt.mesid = m.id)";
		$query .= "   WHERE m.thread={$resultid} ORDER BY m.id " . ($botFirstPosts?"ASC":"DESC") . " LIMIT " . (int)$botPostLimit;

		$db->setQuery($query);
		if (!$rows = $db->loadObjectlist()) {
			$this->debug("Failed to select list of posts to be displayed:" . $db->stderr(), 1);
			return $db->stderr();
		}			
		
		$this->debug("Showing ".($botFirstPosts?"First":"Last")." posts in the thread in ".($botLastPostTop?"Decending":"Ascending")." order.");

		foreach($rows as $post) {

			$showThisPost = 1;
			if ($post->id == $post->thread && $botCopyContent > 0) {
				// For "First Thread Handling" option 2 (value=1), don't show the copied content post.
				// For "First Thread Handling" option 3 (value=2), don't show the link-only post.
				$showThisPost = 0;
				$skipCounter++;  // Only count skipped first-posts, hold will be excluded in the query after this loop.
				$this->debug("Hiding first post with method #".($botCopyContent+1)." of first-thread-handling.");
			}
			if ($post->hold) {
				// This post is not yet approved by moderators.
				$showThisPost = 0;
				$this->debug("Hiding post #{$post->id} as it's pending moderator approval.");
			}
						
			if ($showThisPost) {
				$this->debug("Rendering post #{$post->id}.");
				
				// Do we have any modules in this position?
				$modPos = '';
				if ($displayNum == 1 || $displayNum == 2) {
					// After the first post or after the second post but only if there's another post to follow it.
					// if (mosCountModules("discuss_{$displayNum}")) { 
					if (JDocumentHTML::countModules("discuss_{$displayNum}")) { 
						ob_start();
						// mosLoadModules("discuss_{$displayNum}", -2);
						echo "<jdoc:include type=\"modules\" name=\"discuss_{$displayNum}\" style\"xhtml\"";
						$modPos = "<div class=\"kdb-disc-item kdb-item" . (($displayNum%2)+1) . " discuss_{$displayNum}\">";
						// $modPos .= "<div class=\"fb_discussbot_{$displayNum}\">" . ob_get_contents() . "</div>";
						$modPos .= ob_get_contents();
						$modPos .= "</div>";
						ob_end_clean();
						$displayNum++;
					}
				}
			
				$id = $post->id;
				$post->message = stripslashes(smile::smileReplace($post->message, 0, $fbConfig->disemoticons));
				$post->message = preg_replace('/\n/', "<br />\n", $post->message);
				if ($botPageBreakComment){
				  $sp = '<hr alt="'.$post->subject.'" class="system-pagebreak" title="'.$post->subject.'" />';
        } else {
          $sp = '';
        }
				$sp .= '<div class="kdb-disc-item kdb-item'.(($displayNum%2)+1).'">
						<a name="' . $id . '" id="id' . $id . '" > </a>
						<table width="100%" border="0" cellspacing="0" cellpadding="0"><tbody><tr>
						<td valign="top" style="width:20%;text-align:center;">';

				if ($fbConfig->allowavatar && $post->userid > 0) {
					$sp .= '<div class="kdb-avatar">';
					$sp .= CKunenaLink::GetProfileLink($fbConfig, $post->userid, $this->getAvatar($post->userid), 'kdb-dsc-avatar');
					$sp .= '<br />';
				}
				$sp .= '<span class="kdb-view-username">';
				$sp .=	($post->userid > 0) ? CKunenaLink::GetProfileLink($fbConfig, $post->userid, $post->name) : $post->name;
				$sp .= '</span>';
				if ($fbConfig->allowavatar && $post->userid > 0) {
					$sp .= '</div>';
				}
				// TODO
				$sp .= '</td>
								<td valign="top">
									<div class="kdb-disc-item-cover" ><span class="kdb-dsc-subject"> '.stripslashes($post->subject).'</span><br />
										<span class="kdb-dsc-date">'.gmdate("M d Y H:i:s",$post->time).'</span>
										<div class="kdb-dsc-text" >'.$post->message.'</div>
									</div>
								</td>
								<td valign="top" style="width:5%;text-align:right;">';
							// Ok, this didn't work out because of forum thread pagination from long topics...  
							// Would have been cool but too much effort required to build the URL.
							// $postContent .= '<a href="' 
							// // .  sefRelToAbs("index.php?option=com_kunena&Itemid=" . $Itemid . "&func=view&catid=" . $post->catid . "&id=" . $id) 
							// .  sefRelToAbs("index.php?option=com_kunena&func=view&id=" . $id . "&catid=" . $post->catid) 
							// . "#" . $id . '" title="Jump to this post in the forums">#' . $id 
							// . '</a>';
				$sp .= JText::_('FCKC_HASH') . "$id";
				$sp .= "</td></tr></tbody></table></div>";
				
				
				// ************************************
				if ($botLastPostTop) {
					$s = $s . $modPos . $sp;  // Append to the end
				} else {
					$s = $sp . $modPos . $s; // Prepend to the front!
				}
				$displayNum++;
			}
		}
	
		// Make sure we count all the posts
		$query = "SELECT count(*) FROM `#__fb_messages` WHERE hold=0 AND thread=$resultid";
		$db->setQuery($query);
		if (!$counter = $db->loadResult()) {
			$this->debug("Failed to do a final post count in thread:" . $db->stderr(), 1);
			return $db->stderr();
		}			
		$counter = $counter - $skipCounter;
		
		// Put the title back on the front
		$s = '<div class="kdb-dsc-title">' . sprintf(JText::_('FCKC_DISCUSS_POSTS'), $counter) . '</div>' . $s;
		// ************************************
		if ($countPosts > $botPostLimit) {
			$s .= '<span class="kdb-dsc-too-many">' . JText::_('FCKC_TOO_MANY_TO_LIST') . '</span>';
		}
		// Update with the the number of displayed posts
		$countPosts = $counter;

		return $s;
	}
	/******************************************************************************
	 *  
	 *****************************************************************************/
	function HandlePostFromQuickPost(&$item, &$field, $postPerms, &$resultid, $prefix, $isMod, $catid, $subject, $insertTime, $ipAddy) {
    $this->debug("Call of HandlePostFromQuickPost");
		$botCopyContent = $field->parameters->get('copy_content', 2);  // Copy content item to the first post.  0 = Nothing, 1 = Link & Full Text, 2 = Link Only

		$db = &JFactory::getDbo();
		$my = &JFactory::getUser();
		$fbConfig =& CKunenaConfig::getInstance(); 

		if ((!$my->id && !botAllowPublicPost) || ($my->id && !$postPerms))
			return JText::_('FCKC_YOU_DONT_HAVE_PERMISSION_TO_POST');
		if (JRequest::getString('message','','POST') == '')
			return JText::_('FCKC_YOU_NEED_A_MESSAGE');
		if(JRequest::getString('showing','','POST') != '1')
			return JText::_('FCKC_INVALID_SUBMISSION');
		if(!$my->id && (JRequest::getString('name','','POST') == '')) 
			return JText::_('FCKC_YOU_NEED_A_NICKNAME');

		// Begin captcha
		if ($fbConfig->captcha && !$my->id) {
			$number = $_POST['txtNumber'];
			$session =& JFactory::getSession();
			$rand = $session->get('fb_image_random_value');
			unset($session);
		    	if (md5($number) != $rand) {
				echo "<script language='javascript' type='text/javascript'>alert('".JText::_('FCKC_KUNENA_CAPERR')."')</script>";
				echo "<script language='javascript' type='text/javascript'>window.history.back()</script>";
				return;
				//$app->close();
				//break;
			}
		}
		// Finish captcha
			
		if($my->id) {
			$username = $fbConfig->username ? $my->username : $my->name;
			$email = $my->email;
		} else {
			$username = JRequest::getString('name','','POST');
			$email = JRequest::getString('email','','POST');
		}
		$username = trim(addslashes($username));
		$email = trim(addslashes($email));

		$thread = $resultid; 
		$contentURL = '';
		// Only build a link back to the content for NEW threads.
		if ($thread == '' || $thread == 0) {
			$contentURL = $prefix;
			// If inserting content as the first post, we should do it here then set the threadid to the Id of the new post
			if ($botCopyContent > 0) {
				$thread = $this->InsertContentAsFirstPost($item, $field, $catid, $subject, $contentURL, $insertTime, $ipAddy);
				// Since we've added records, we need the new ThreadId after processing QuickPost
				$resultid = $thread;
				$contentURL = '';
			}
		}
		$parent = $thread;
			
		$message = '';
		if ($contentURL) {
			$message = $contentURL . "\n\n" . $message;
		}
		// Changed in version 1.0.8
		// $message .= trim(htmlspecialchars(addslashes(kdbCheck($_POST['message']))));
		// For some reason we were putting messages into the DB like this:
		// &quot;Show me the money!&quot;
		// instead of this:
		// I\'ll \"Show you *my* money\"...
		$message .= trim(addslashes(JRequest::getString('message','','POST')));
			
		// If user is not a moderator we may want to hold this post
		if ($isMod) {
			$holdPost = 0;
		} else {
			$db->setQuery("SELECT review FROM #__fb_categories WHERE id=$catid");
			$holdPost = $db->loadResult();
		}
			
		$query = "INSERT INTO #__fb_messages (id, parent, thread, catid, name, userid, email, subject, time, ip, hold) VALUES ('', '$parent', '$thread', '$catid', '$username', '{$my->id}', '$email', '$subject', '$insertTime', '$ipAddy', '$holdPost')";
		$db->setQuery($query);
		if (!$db->query()) {
			$this->debug("Failed to insert new quickpost:" . $db->stderr(), 1);
			return $db->stderr();
		}		
		// Reselect the new ID using the value for timestamp
		$query = "SELECT min(id) FROM #__fb_messages WHERE time='$insertTime'";
		$db->setQuery($query);
		if (!$newMessageId = $db->loadResult()) {
			$this->debug("Failed to select new quickpost threadId:" . $db->stderr(), 1);
			return $db->stderr();
		}		
		// We need to Update new Threads with the thread ID
		if (!$thread) {
			$db->setQuery("UPDATE #__fb_messages set thread = id WHERE id='$newMessageId'");
			if (!$db->query()) {
				$this->debug("Failed to update quickpost with the threadId:" . $db->stderr(), 1);
				return $db->stderr();
			}
			// We'll need to know about the new Thread id later...
			$resultid = $newMessageId;
		}			
			
		$query = "INSERT INTO #__fb_messages_text(mesid, message) VALUES ($newMessageId, '$message')";
		$db->setQuery($query);
		if (!$db->query()) {
			$this->debug("Failed to insert new quickpost message text:" . $db->stderr(), 1);
			return $db->stderr();
		}
		// Update the user posts count because that's very important to people!!!  ;)
		if ($my->id) {
			$db->setQuery("UPDATE #__fb_users SET posts=posts+1 WHERE userid={$my->id}");
			if (!$db->query()) {
				$this->debug("Failed to update users post count by quickpost:" . $db->stderr(), 1);
				return $db->stderr();
			}
		}
			
		// Update the category with the last post info
		$query = "UPDATE #__fb_categories SET time_last_msg='$insertTime', id_last_msg='$newMessageId', numPosts = numPosts+1 WHERE id = '$catid'";
		$db->setQuery($query);
		if (!$db->query()) {
			$this->debug("Failed to update category thread count by quickpost:" . $db->stderr(), 1);
			return $db->stderr();
		}
			
		 // Handle User subscrtiptions and Moderator notifications.
		$this->DoSubscriptions($thread, $newMessageId, $message, $subject, $catid);
			
		if ($holdPost) {
			$result = JText::_('FCKC_PENDING_MODERATOR_APPROVAL');
		} else {
			$result = JText::_('FCKC_YOUR_MESSAGE_HAS_BEEN_POSTED');
		}

		// Redirect 
		$uri =& JFactory::getURI();
		$mainframe =& JFactory::getApplication('site');
		$mainframe->redirect($uri->toString(), $result);
	}
	
	/******************************************************************************
	 *  
	 *****************************************************************************/
	function BuildQuickPostForm(&$item, &$field) {
    $this->debug("Call of BuildQuickPostForm");
		$botSmilies = $field->parameters->get('show_smilies', 0);  // Show Smilies with Quick Post.  0 = Don't show, 1 = Show on Left, 2 = Show on right
		$botQuickPostOpen = $field->parameters->get('quickpost_open', false);  // Default state for the QuickPost Form.  0 = Collapsed, 1 = Open 
	 
		$my = &JFactory::getUser();
	
		$fbConfig =& CKunenaConfig::getInstance(); 
	
		$s = '';
		$smilies = '';
		if ($botSmilies) {
			// Output buffering 'cause the generate_smilies() function 
			// echos it's output instead of returning it in a variable.  Grrr!!
			require_once(KUNENA_PATH_LIB.DS.'kunena.bbcode.js.php');
			
			ob_start();
			generate_smilies();
			$smilies = "<table class='kdb-quick-post-smilies' cellspacing=0 cellpadding=0>" . ob_get_contents() . "</table>";
			// Hide the "More Smilies" link - it's broken!
			$smilies = str_replace("onclick=\"javascript:dE('smilie');\" style=\"cursor:pointer\"", "style=\"display:none;\"", $smilies);
			ob_end_clean();
			$this->debug("Smilies displayed " . ($botSmilies == 1?"Left":"Right") . " of the QuickPost form.");
		}
		
		//. Set the state of the QuickPost form adding option to toggle if it's closed.
		if ($botQuickPostOpen) {
			$s .= '<span class="kdb-quick-post-title">' . JText::_('FCKC_QUICK_POST') . '</span>';
			$s .= '<div id="quickPost'.$item->id.'">';
		} else {
			$s .= '<a href="#" class="kdb-quick-post-toggle" onclick="toggleQuickPost('.$item->id.'); return false;">'.JText::_('FCKC_QUICK_POST').'</a>';
			$s .= '<div id="quickPost'.$item->id.'" style="display:none;">';
		}
		$s .= '<br /><form method="post" name="postform" onSubmit="return validate(this);">';
		$s .= "<table cellspacing=0 cellpadding=0><tr>";
		// 1 == Smilies on the Left
		if ($botSmilies == 1) {
			$s .= "<td valign='bottom'>" . $smilies . "</td>";
		}
		$s .= "<td valign='top'>";
	
		$s .= "<table border=0 cellpadding=0>";  // Open a field layout table
		if($my->id) {
			$s .='<tr><td style="width:10%;"><span class="kdb-quick-post-label">'.JText::_('FCKC_NICKNAME').'&nbsp;</span></td>';
			$s .=  '<td>' . ($fbConfig->username ? $my->username : $my->name);
			$s .=  '<input type="hidden" name="name" value="">';
			$s .=  '<input type="hidden" name="email" value=""></td></tr>' . "\n";
		} else {
			$s .='<tr><td style="width:10%;"><span class="kdb-quick-post-label">'.JText::_('FCKC_NICKNAME').'&nbsp;</span></td>';
			$s .=  '<td><input type="text" name="name" value=""></td></tr>' . "\n";
			
			$s .='<tr><td style="width:10%;"><span class="kdb-quick-post-label">'.JText::_('FCKC_EMAIL').'&nbsp;</span></td>';
			$s .=  '<td><input type="text" name="email" value=""></td></tr>' . "\n";
		}
	
		// Begin captcha . Thanks Adeptus
		if ($fbConfig->captcha && !$my->id)
			$s .= JText::_('FCKC_KUNENA_CAPDESC').'&nbsp;<input name="txtNumber" type="text" id="txtNumber" value="" style="vertical-align:middle" size="10">&nbsp;<img src="index2.php?option=com_kunena&func=showcaptcha" alt="" /><br />';
		// Finish captcha

		$s .= '<tr><td style="width:10%;"><span class="kdb-quick-post-label">'.JText::_('FCKC_MESSAGE').'</span><input type="hidden" name="showing" id="showing'.$item->id.'" value="'.$botQuickPostOpen.'"></td></tr>' . "\n";  // Simple test to know a user clicked the link first
		$s .= '<tr><td colspan="2"><textarea name="message" rows="5" cols="60"></textarea></td></tr>' . "\n";
		$s .= '<tr><td style="width:10%;"><input type="submit" class="button" value="'.JText::_('FCKC_SUBMIT_BUTTON').'"/></td></tr>' . "\n";
		$s .= "</table>\n"; // Close field layout table
		$s .= '</td>' . "\n";
		// 2 == Smilies on the Right
		if ($botSmilies == 2) {
			$s .= "<td valign='bottom'>" . $smilies . "</td>";
		}
		$s .= "</tr></table>";
		// Include the Id of the item to be discussed.
		$s .= '<input type="hidden" name="kdbContentId" value="' . $item->id . '">';
		$s .= '</form>';
		$s .= '</div>';
				
		return $s;
	}
 
   
  	/******************************************************************************
	 *  Determine if the user has Post permission on this thread
	 *****************************************************************************/
	function HasPostPerms($catid, $replyto, $ismod) {
    $this->debug("Call of HasPostPerms");
		$db = &JFactory::getDbo();
		$my = &JFactory::getUser();
	
		$fbConfig =& CKunenaConfig::getInstance(); 

		if ($ismod)
        		return true;
		if (!($fbConfig->pubwrite || $my->id))
			return false;

		if ($replyto) {
			$db->setQuery("select thread from #__fb_messages where id=$replyto");
			$topicID = $db->loadResult();
			if (!$topicID)
				$topicID = $replyto; 

			$db->setQuery("select locked from #__fb_messages where id=$topicID");
			$threadLock = $db->loadResult();
			if ($threadLock)
				return false;
		}
	
		// If the Thread isn't locked, check to see if the forum Category is locked.
		//topic not locked; check if forum is locked
		$db->setQuery("select locked from #__fb_categories where id=$catid");
		$topicLock = $db->loadResult();
		return !$topicLock;
	}

	/******************************************************************************
	 *  Determine if the user is a Moderator on this forum.
	 *****************************************************************************/
	function IsModerator($catid) {
    $this->debug("Call of IsModerator");
		$my = &JFactory::getUser();

		if (!$my->id) return false;

		require_once(KUNENA_PATH_LIB.DS.'kunena.permissions.php');
		require_once(KUNENA_PATH_LIB.DS.'kunena.category.class.php');
	
		// User is logged on - we have to check if they're a Moderator.
		$acl = &JFactory::getACL();
		$aro_group = $acl->getAroGroup($my->id); 
		$is_admin = (strtolower($aro_group->name) == 'super administrator' || strtolower($aro_group->name) == 'administrator');
		
		$db = &JFactory::getDbo();
		$obj_fb_cat = new jbCategory($db, $catid);
		return fb_has_moderator_permission($db, $obj_fb_cat, $my->id, $is_admin);
	}

	/******************************************************************************
	 *  Process subscriptions and whatnot...
	 *****************************************************************************/
	function DoSubscriptions ($thread, $pid, $message, $messagesubject, $catid) {
    $this->debug("Call of DoSubscriptions");
		$db = &JFactory::getDbo();
		$my = &JFactory::getUser();	
	
		$fbConfig =& CKunenaConfig::getInstance();
	
		require_once(KUNENA_PATH_LIB.DS.'kunena.mail.php'); // include class for mailing
	
		$db->setQuery("SELECT name FROM #__fb_categories WHERE id={$catid}");
		if (!$catName = $db->loadResult()) {
			$this->debug("Failed to select category name:" . $db->stderr(), 1);
			echo $db->stderr();
			return;
		}
	
		//Now manage the subscriptions (only if subscriptions are allowed)
		if ($fbConfig->allowsubscriptions) {
			
			// Get the Board title from the fb config
			$board_title = $fbConfig->board_title;
	
			// Get info about the user who is posting
			$ip = $_SERVER["REMOTE_ADDR"];
			
			// get the proper user credentials for each subscription to this topic
			if (!$thread) {
				$querythread = $pid;
			} else {
				$querythread = $thread;
			}
	
			$this->debug("Processing subscriptions for thread #{$querythread}.");
	
			//clean up the message
			$mailmessage = smile::purify($message);
			$db->setQuery("SELECT u.id, u.name, u.email FROM #__fb_subscriptions AS a LEFT JOIN #__users as u ON a.userid=u.id WHERE a.thread=$querythread");
	
			$subsList = $db->loadObjectList();
			//construct a useable URL (for plaintext - so no &amp; encoding!)
			$messageUrl = JRoute::_("index.php?option=com_kunena&func=view&catid=$catid&id=$pid") . "#$pid";
	
			
			if (count($subsList) > 0) { 
				//we got more than 0 subscriptions
				
				foreach ($subsList as $subs) {
					$mailsubject = sprintf(JText::_('FCKC_NEW_POST_NOTIFICATION'), JText::_('FCKC_GEN_SUBJECT'), stripslashes($messagesubject), JText::_('FCKC_KUNENA_IN_FORUM'), stripslashes($catName));
					$msg = $subs->name . ",\n";
					$msg .= sprintf(JText::_('FCKC_NEW_POST_TO_TOPIC'), $board_title, JText::_('FCKC_KUNENA_FORUM'));
					$msg .= $mailsubject . "\n";
					$msg .= JText::_('FCKC_VIEW_POSTED').": " . stripslashes($my->name) . "\n\n";
					$msg .= JText::_('FCKC_ADMIN_YOUR_SUBS') . "\n";
					$msg .= "URL: {$messageUrl}\n\n";
					if ($fbConfig->mailfull == 1) {
						$msg .= JText::_('FCKC_GEN_MESSAGE').":\n";
						$msg .= stripslashes($mailmessage);
					}
					$msg .= "\n\n" . JText::_('FCKC_GENERATED_MAIL') . "\n\n\n\n\n\n";
					$msg .= "** Powered by Kunena Discuss **";
	
					if ($ip != "127.0.0.1" && $my->id != $subs->id) { //don't mail yourself
						$this->debug("Sending subscription notice ({$mailsubject}) to {$subs->email}.");
						JUtility::sendMail($fbConfig->email, JText::_('FCKC_KUNENA_FORUM_AT')." " . $_SERVER['SERVER_NAME'], $subs->email, $mailsubject, $msg);
					} else {
						$this->debug("Skipped sending subscription notice ({$mailsubject}) to {$subs->email}.");
					}
				}
			}
		}
	
		//Now manage the mail for moderator or admins (only if configured)
		if($fbConfig->mailmod || $fbConfig->mailadmin) {
			//they're configured
			//get the proper user credentials for each moderator for this forum
			$sql = "SELECT u.id, u.name, u.email FROM #__users AS u";
			if($fbConfig->mailmod)
				$sql .= " LEFT JOIN #__fb_moderation AS a ON a.userid=u.id AND a.catid=$catid WHERE a.userid IS NOT NULL";
			if ($fbConfig->mailadmin) 
				if ($fbConfig->mailmod) {
					$sql .= " OR u.sendEmail=1";
				} else {
					$sql .= " WHERE u.sendEmail=1";
				}
			$db->setQuery($sql);
			$modsList = $db->loadObjectList();
	
			if (count($modsList) > 0) {
				//we got more than 0 moderators eligible for email
				foreach ($modsList as $mods) {
					$mailsubject = sprintf(JText::_('FCKC_NEW_POST_NOTIFICATION'), JText::_('FCKC_GEN_SUBJECT'), stripslashes($messagesubject), JText::_('FCKC_KUNENA_IN_FORUM'), stripslashes($catName));
					$msg = $mods->name . ",\n";
					$msg .= sprintf(JText::_('FCKC_NEW_POST_TO_MODERATE'), $board_title, JText::_('FCKC_KUNENA_FORUM')) . "\n";
					$msg .= $mailsubject . "\n";
					$msg .= JText::_('FCKC_VIEW_POSTED').": " . stripslashes($my->name) . "\n\n";
					$msg .= JText::_('FCKC_MODERATOR_PLEASE_REVIEW') . "\n";
					$msg .= "URL: {$messageUrl}\n\n";
					if ($fbConfig->mailfull == 1) {
						$msg .= JText::_('FCKC_GEN_MESSAGE') . ":\n";
						$msg .= stripslashes($mailmessage);
					}
					$msg .= "\n\n" . JText::_('FCKC_GENERATED_MAIL') . "\n\n\n\n\n\n";
					$msg .= "** Powered by Kunena Discuss **";
	
					if ($ip != "127.0.0.1" && $my->id != $mods->id) { //don't mail yourself
						//Send away
						$this->debug("Sending moderator notice ({$mailsubject}) to {$mods->email}.");
						JUtility::sendMail($fbConfig->email, "Forum at " . $_SERVER['SERVER_NAME'], $mods->email, $mailsubject, $msg);
					} else {
						$this->debug("Skipped sending moderator notice ({$mailsubject}) to {$mods->email}.");
					}
				}
			}
		}
		// TODO: Add ability to subscribe new posters
		$subscribeMe = false;
		//now try adding any new subscriptions if asked for by the poster
		if ($subscribeMe) {
			if (!thread) 
				$fb_thread = $pid;
			else 
				$fb_thread = $thread;
	
			$db->setQuery("INSERT INTO #__fb_subscriptions (thread,userid) VALUES ('$fb_thread','{$my->id}')");
			if ($db->query())
				echo JText::_('FCKC_POST_SUBSCRIBED_TOPIC') . "<br /><br />";
			else
				echo JText::_('FCKC_POST_NO_SUBSCRIBED_TOPIC') . "<br /><br />";
		}
	}

	function debug($msg, $fatal=0) {
		$debug = $this->_debug;  // Print out debug info!
		$debugUsers = '';

		$my = &JFactory::getUser();
	
		if (!$debug)
			return;
		if ($debugUsers && !in_array($my->id, explode(',', $debugUsers))) 
			return;

		if ($fatal) {
			//echo "<br /><span class=\"kdb-fatal\">[KDiscuss FATAL: $msg ]</span>";
			error_log("[KComment FATAL: $msg ]");
		} else {
			//echo "<br />[KDiscuss debug: $msg ]";
			error_log("[Kcomment debug: $msg ]");
		}
	}

}